/*
** File: adb3_common.h  
** Project: ADB3 core driver
** Purpose: Prototype of common ADB3 methods
**
** (C) Copyright Alpha Data 2010
*/

#ifndef _ADATA_CORE_ADB3_COMMON_H
#define _ADATA_CORE_ADB3_COMMON_H

#include "device.h"

extern void
adb3DmaList(
  Adb3CoreDeviceContext* pDevCtx,
  boolean_t bWriteToDevice,
  boolean_t bFixedLocal,
  DfDmaMapperNode* pTable,
  unsigned int tableLength,
  DmaNodeTablePosition* pTablePosition,
  void* pDescriptorBuffer,
  unsigned int maxDescriptor,
  uint64_t descriptorBusAddress);

extern void
adb3DmaTransfer(
  Adb3CoreDeviceContext* pDevCtx,
  unsigned int channel,
  boolean_t bStart,
  void* pDescriptorBuffer,        /* Valid iff 'bStart' is TRUE */
  uint64_t descriptorBusAddress); /* Valid iff 'bStart' is TRUE */

extern void
adb3DumpDmaDescriptors(
	Adb3CoreDeviceContext* pDevCtx,
  Adb3DmaDescriptor* pDescriptors,
  uint64_t descBus,
  unsigned int count);

extern void
adb3DumpDmaRegisters(
	Adb3CoreDeviceContext* pDevCtx,
  unsigned int channel);

extern boolean_t
adb3VerifyChecksum(
	Adb3CoreDeviceContext* pDevCtx,
  uint16_t vpdLength);

#endif
