/*
** File: flash.h  
** Project: ADMXRC3 module driver
** Purpose: Defines function prototypes for Flash programming IOCTL handlers.
**
** (C) Copyright Alpha Data 2009
*/

#if !defined(ADATA_ADMXRC3_FLASH_H)
#define ADATA_ADMXRC3_FLASH_H

#include <df.h>
#include "device.h"

extern DfIoStatus
ioctlEraseFlash(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetFlashBlockInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlGetFlashInfo(
	Admxrc3DeviceContext* pDevCtx,
  void* pBuffer,
  unsigned int inSize,
  unsigned int outSize);

extern DfIoStatus
ioctlReadFlash(
	Admxrc3DeviceContext* pDevCtx,
	Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlReadFlashThunk(
	Admxrc3DeviceContext* pDevCtx,
	Admxrc3ClientContext* pClCtx,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteFlash(
	Admxrc3DeviceContext* pDevCtx,
	Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

extern DfIoStatus
ioctlWriteFlashThunk(
	Admxrc3DeviceContext* pDevCtx,
	Admxrc3ClientContext* pClCtx,
  DfClientRequest* pReq,
  void* pBuffer,
  unsigned int inSize);

#endif
